#coding: utf-8

class ModelController < ApplicationController

  def get_all
    @articles = Article.all
  end

  def get_find
   @article = Article.find(1)
   render 'articles/show'
  end

  def get_find2
   @articles = Article.find(1, 3, 5)
   render 'get_all'
  end

  def dynamic_find
    @article = Article.find_by_title('ASP.NET MVC入門')
    render 'articles/show'
  end

  def dynamic_all_find
    @users = User.find_all_by_roles('member')
    render 'users/index'
  end

  def first_last
    @article = Article.order('published DESC').first
    #@article = Article.order('published').last
    render 'articles/show'
  end


  def query_where
    @articles = Article.where(:closed => true)
    #@articles = Article.where(:category => 'Script', :closed => false)
    #@articles = Article.where(:published => '2011-01-01'..'2011-06-30')
    #@articles = Article.where(:category => ['.NET', 'Script'])
    render 'get_all'
  end

  def query_place
    @articles = Article.where('category = ? AND published > ?',
      'Script', '2011-01-01')
    #@articles = Article.where(
    #  'category = :category AND published > :published',
    #  { :category => 'Script', :published => '2011-01-01' })
    render 'get_all'
  end

  def query_sort
    @articles = Article.order('published')
    #@articles = Article.order('published DESC, title')
    #@articles = Article.order('published DESC').reorder('title')
    #@articles = Article.order('published DESC').reorder(nil)
    render 'get_all'
  end

  def query_limit
    @articles = Article.order('published DESC').limit(5).offset(3)
    render 'get_all'
  end

  def query_paging
    psize = 3
    pnum = params[:id] == nil ? 0 : params[:id].to_i - 1
    @articles = Article.order('title').limit(psize).offset(psize * pnum)
    render 'get_all'
  end

  def query_select
    @articles = Article.where('published > 2011-01-01').
     select('url, title, published, strftime("%Y-%m", published) AS y_pub')
    render 'get_all'
  end

  def query_group
    @articles = Article.group('category').
      select('category, SUM(access) AS cnt')
  end

  def query_having
    @articles = Article.group('category').
      select('category, SUM(access) AS cnt').
      having(['SUM(access) > ?', 600])
    render 'query_group'
  end

  def query_except
    @articles = Article.where('category = ?', 'Script').
      order('publish DESC').select('url, title, published').
      except(:order, :where)
    render 'get_all'
  end

  def total
    @count = Article.where('category = ?', 'Script').average(:access)
    #@count = Article.count()
    #@count = Article.where('category = ?', 'Script').sum(:access)
    #@count = Article.maximum(:access)
    #@count = Article.minimum(:access)
    render :text => "#{@count}件です。"
  end

  def reload_model
    @article = Article.find(1)
    msg = @article.title + '<br />'
    @article.title = 'Rails入門'
    msg += @article.title + '<br />'
    @article.reload
    msg += @article.title
    render :text => msg
  end

  def sql_model
    @articles = Article.find_by_sql(['SELECT category, SUM(access) AS cnt FROM "articles" GROUP BY category HAVING SUM(access) > ?', 300])
    render 'query_group'
  end

  def exists_model
    flag = Article.exists?
    #flag = Article.exists?(2)
    #flag = Article.where(:category => 'Java').exists?
    #flag = Article.exists?({ :category => 'Script' })
    #flag = Article.exists?(['access > ?', 100])
    render :text => flag
  end

  def attrs_model
    @article = Article.find(1)
    render :text => @article.attributes['title']
  end

  def attr_names
    render :text => Article.attribute_names
  end

  def basic_scope
    @articles = Article.script.whats_new5
    render 'get_all'
  end

  def basic_scope2
    @articles = Article.whats_new('Script', 3)
    render 'get_all'
  end

  def def_scope
    @comments = Comment.all
    render 'comments/index'
  end

  def unscope
    @comments = Comment.unscoped.all
    # @comments = Comment.unscoped { Comment.all }
    render 'comments/index'
  end

  def save_model
    @article = Article.new
    @article.url = 'http://codezine.jp/article/corner/324'
    @article.title = 'mixiアプリで始めるOpenSocial入門'
    @article.category = 'Other'
    @article.published = '2009-09-23'
    @article.access = 81
    @article.closed = true
    if @article.save
      render :text => '保存できました。'
    else
      render :text => '保存に失敗しました。'
    end
  end

  def create_model
    @article = Article.create(
      :url => 'http://codezine.jp/article/corner/382',
      :title => 'jQueryプラグインの活用',
      :category => 'Other',
      :published => '2010-07-27',
      :access => 150,
      :closed => false
    )
    if !@article.new_record?
      render :text => '保存できました。'
    else
      render :text => '保存に失敗しました。'
    end
  end

  def attr_update
    @article = Article.find(1)
    @article.update_attribute(:published, '2011-03-30')
    render :text => 'published列を更新しました。'
  end

  def attrs
    @article = Article.find(12)
      @article.attributes= {
        :url => 'http://codezine.jp/article/corner/382',
        :title => 'jQuery UIの活用'
      }
      #@article.assign_attributes(
      #  :url => 'http://codezine.jp/article/corner/382',
      #  :title => 'jQuery UIの活用')
    if @article.save
      render :text => '保存できました。'
    else
      render :text => '保存に失敗しました。'
    end
  end

  def update_model
     Article.update(12, { :title => 'jQueryプラグインの利用', 
       :url => 'http://codezine.jp/article/corner/382' })
    #Article.update(
    #  [11, 12],
    #  [{ :title => 'mixiアプリでOpenSocial入門'},
    #   { :title => 'jQueryプラグインの応用'}])
    render :text => '更新に成功しました。'
  end

  def update_all
    @cnt = Article.update_all('access = access - 100',
      ['category = ?', 'Script'])
    #@cnt = Article.update_all('access = access - 100', nil,
    #  { :order => 'published DESC', :limit => 3 })
   render :text => "#{@cnt}件のデータを更新しました。"
  end

  def protect_access
    @user = User.find(1)
    msg = @user.roles + '<br />'
    @user.assign_attributes(:name => 'nkakeya', :roles => 'users')
    msg += @user.roles + '<br />'
    render :text => msg
  end

  def protect_access2
    @user = User.find(1)
    msg = @user.name + '|' + @user.roles + '<br />'
    @user.assign_attributes(:name => 'nkakeya', :roles => 'users')
    msg += @user.name + '|' + @user.roles + '<br />'
    @user.assign_attributes({ :name => 'tsuzuki', :roles => 'users' },
      :as => :admin)
    msg += @user.name + '|' + @user.roles
    render :text => msg
  end

  def delete_destroy
    Article.delete(11)
    # @article = Article.find(11)
    # @article.delete()
    Article.destroy(12)
    # @article = Article.find(12)
    # @article.destroy()
    render :text => '削除しました。'
  end

  def delete_destroy_all
    #Article.destroy_all(['category = ?', 'Script'])
    #Article.delete_all(['category = ?', 'Script'])
     Article.where('category = ?', 'Script').delete_all()
    render :text => '削除しました。'
  end

  def rec_state
    msg = 'new｜per｜chg｜des<br />'
    @article = Article.new(:url => 'http://codezine.jp/article/corner/363', 
      :title => 'Struts 2入門', :category => 'Other', 
      :published => '2010-03-16', :access => 79, :closed => false)
    msg += state_disp(@article)
    @article.save
    msg += state_disp(@article)
    @article.title = '続 Struts 2入門'
    msg += state_disp(@article)
    @article.save
    @article.destroy
    msg += state_disp(@article)
    render :text => msg
  end

  def state_disp(atc)
    atc.new_record?.to_s + '｜' + atc.persisted?.to_s + '｜' +
      atc.changed?.to_s + '｜' + atc.destroyed?.to_s + '<br />'
  end

  def change_state
    @article = Article.find(1)
    @article.category = 'Script'
    msg = change_disp(@article)
    @article.save
    msg += change_disp(@article)
    render :text => msg
  end

  def change_disp(atc)
    sprintf('%s<br />%s<br />%s<br />%s<hr />',
      atc.changed.to_s,
      atc.changed_attributes.to_s,
      atc.changes.to_s,
      atc.previous_changes.to_s)
  end

  def inc_dec
    @article = Article.find(1)
    @article.increment (:access)
    @article.save
    @article.decrement (:access)
    @article.save
    render :text => 'アクセス数を更新しました。'
  end

  def togg
    @article = Article.find(1)
    @article.toggle (:closed)
    @article.save
    render :text => '非公開サインを更新しました。'
  end

  def touch
    @article = Article.find(1)
    @article.touch
    render :text => '更新年月日を更新しました。'
  end

  def transact
      Article.transaction do
        article1 = Article.new({ :url => 'http://codezine.jp/article/corner/245' })
        article1.save!
        raise 'データ登録時に問題が発生しました。'
        article2 = Article.new({ :url => 'http://codezine.jp/article/corner/224' })
        article2.save!
      end
      render :text => 'トランザクション処理は成功しました。'
    rescue => e
      render :text => '例外発生：' + e.message
  end

  def pessimis
    @article = Article.where(:category => 'Script').lock.all
    #@article = Article.find(1, :lock => true)
    #@article = Article.find(1)
    #@article.lock!
    render :text => 'ロックの例です。'
  end

  def raw_sql
    @article = ActiveRecord::Base.connection.
      execute('SELECT * FROM articles WHERE id = 1')
    render :text => @article.inspect
  end

  def cache_counter
    @article = Article.find(1)
    render :text => @article.comments.size
  end


  def upload
    @id = params[:id] ? params[:id] : 1
    @photo = Photo.new
  end

  def upload_process
    @article = Article.find(params[:id])
    @photo = @article.photos.build(params[:photo])
    if @photo.save
      render :text => 'アップロードに成功しました。'
    else 
      render :text => @photo.errors.full_messages[0]
    end
  end

  def belongs
    @comment = Comment.find(1)
    render :text => @comment.article.title + ' : ' + @comment.body
  end

  def hasmany
    @article = Article.find(1)
    @comments = @article.comments
  end

  def hasone
    @user = User.find(1)
    @author = @user.author
  end

  def has_belongs
    @article = Article.find(2)
    @authors = @article.authors
  end

  def hasmany_through
    @user = User.find(3)
    @articles = @user.articles
  end

  def assoc_opts
    @author = Author.find(2)
    render :text => @author.awards.inspect
  end

  def assoc_coll
    @article = Article.find(1)
  end

  def assoc_coll_set
    @user = User.find(1)
    @author = Author.new({ :penname => 'しまじろう', :birth => '1980-10-15' })
    @user.author = @author

    @article = Article.find(1)
    @comment1 = Comment.new({ :id => 10, :user_id => 4,
      :body => 'まだ途中ですが、今のところついて行っています。' })
    @comment1.save
    @comment2 = Comment.new({ :id => 11, :user_id => 6,
      :body => '職場で使っています。自宅にもほしい。' })
    @comment2.save
    @article.comments= [ @comment1, @comment2 ]

    @article = Article.find(2)
    @comment1 = Comment.new({ :user_id => 4,
      :body => 'サンプルが参考になります。' })
    @comment1.save
    @comment2 = Comment.new({ :user_id => 5, :body => 'わかりやすいです。' })
    @comment2.save
    @article.comment_ids= [ @comment1.id, @comment2.id ]

    @article = Article.find(3)
    @comment = Comment.new({ :user_id => 4, :body => 'いつも手元に置いています。' })
    @article.comments << @comment
    render :text => '処理に成功しました。'
  end

  def build_create
    @user = User.find(6)
    @author = @user.build_author({ :penname => 'marimba', :birth => '1982-09-13' })
    @author.save

    @user = User.find(7)
    @user.create_author({ :penname => 'はらしょう', :birth => '1978-04-11' })

    @article = Article.find(4)
    @comments = @article.comments.build([
      { :user_id => 6, :body => 'デザインの勉強によいです。' },
      { :user_id => 7, :body => '理解できました。' }
    ])
    @comments[0].save
    @comments[1].save

    @article = Article.find(5)
    @comments = @article.comments.create([
      { :user_id => 4, :body => 'おもしろいです。' },
      { :user_id => 5, :body => 'サンプル作ってみました。' }
    ])

    render :text => '処理に成功しました。'
  end

  def coll_delete
    @article = Article.find(1)
    @comments = @article.comments
    @article.comments.delete(@comments[0])
    @article.comments.clear
    render :text => '処理に成功しました。'
  end

  def coll_ids
    @article = Article.find(2)
    render :text => @article.title + '：' + @article.comment_ids.to_s
  end

  def empty_exists
    @article = Article.find(2)
    render :text => @article.comments.empty?.to_s +
      '：' + @article.comments.exists?.to_s
  end

  def coll_size
    @article = Article.find(3)
    render :text => 'コメント件数：' + @article.comments.size.to_s
  end

  def assoc_join
    @articles = Article.joins(:comments, :authors).
      order('articles.title, authors.penname').
      select('articles.*, comments.body, authors.penname')
  end

  def assoc_join2
    @articles = Article.joins(:comments => :user).
      select('articles.*, comments.body, users.kname')
  end

  def assoc_join3
    @articles = Article.joins('LEFT JOIN comments ON comments.article_id = articles.id').select('articles.*, comments.body')
  end

  def assoc_includes
    @articles = Article.includes(:authors).all
  end

  def keywd
    @search = SearchKeyword.new
  end

  def keywd_process
    @search = SearchKeyword.new(params[:search_keyword])
    if @search.valid?
      render :text => params[:search_keyword][:keyword]
    else
      render :text => @search.errors.full_messages[0]
    end
  end

end
