#coding: utf-8

class OtherController < ApplicationController

  http_basic_authenticate_with :realm => 'Railsample', :only => :a_cache,
    :name => 'yyamada', :password => '12345'
  caches_action :a_cache, :expires_in => 30.minutes
  caches_page :p_cache
  caches_page :if_cache, :if => Proc.new { |c| !c.request.format.xml? }

  def basic_mail
    @user = User.find(1)
    ReportMailer.user_update(@user).deliver
    render :text => 'メールを送信しました。'
  end

  def p_cache
    render :text => Time.now.to_s
  end

  def if_cache
    respond_to do |format|
      format.html { render :text => Time.now.to_s }
      format.xml  { render :xml  => '<result>' + Time.now.to_s + '</result>' }
    end
  end

  def a_cache
    render :text => Time.now.to_s
  end

  def cache_ex
    unless fragment_exist?(:controller => :other, :action => :cache_ex)
      @articles = Article.all
    end
  end

  def paging
    #WillPaginate.per_page = 3
    @articles = Article.order('published DESC').
      paginate(:page => params[:page], :per_page => 3)
  end

  def paging_inf
    @articles = Article.paginate(:page => 2, :per_page => 3)
  end

  def delayed
    @user = User.find(1)
    ReportMailer.delay.user_update(@user)
    render :text => '実行が完了しました。'
  end
end
