#coding: utf-8

module ApplicationHelper
  def current_time
   Time.now.strftime '%Y年%m月%d日 %H:%M:%S'
  end

  #def bulleted_list(models, url_field = 'url', title_field = 'title')
  #  content_tag(:ul) do
  #    models.each do |model|
  #      concat content_tag(:li,
  #        link_to(model.attributes[title_field],
  #          model.attributes[url_field]))
  #    end
  #  end
  #end

  def bulleted_list(models, url_field = 'url',
    title_field = 'title', start = 1, options = {})
    options.merge! :start => start
    content_tag(:ol, options) do
      models.each do |model|
        concat content_tag(:li,
          link_to(model.attributes[title_field],
            model.attributes[url_field]))
      end
    end
  end

  def code_tag(caption, code = '', clazz = 'code', &block)
    code_text = content_tag(:pre) do
      content_tag(:code, 
        block_given? ? capture(&block) : code,
        :class => clazz)
    end
    p_text = content_tag(:div, '▲' + caption)
    code_text.concat(p_text)
  end

end
