class ArticleSweeper < ActionController::Caching::Sweeper
  observe Article

  def after_create(article)
    exp_cache(article)
  end

  def after_update(article)
    exp_cache(article)
  end

  def after_destroy(article)
    exp_cache(article)
  end

  private
  def exp_cache(article)
    expire_action :controller => 'articles', :action => 'index'
    expire_action :controller => 'articles', :action => 'show',
      :id => article.id
  end
end
