#coding: utf-8
# EmailValidatorバリデータファイル
# Author:: YAMADA,Yoshihiro
# Date::   2011.11.01

# メールアドレスの妥当性を検証するためのバリデータクラス
class EmailValidator < ActiveModel::EachValidator

  # メールアドレスの妥当性をチェックします。
  # ==== Parameters
  # * +record+ - 検証対象のレコード
  # * +attr+ - 検証対象のフィールド名
  # * +value+ - 検証対象の値
  # ==== Examples
  #   validates :email, :email => true
  def validate_each(record, attr, value)
    record.errors.add(attr, 'はメールアドレスの形式で入力してください。') unless value =~ /^\w+([\-+.']\w+)*@\w+([\-.]\w+)*\.\w+([\-.]\w+)*$/
  end
end
