#coding: utf-8

require 'test_helper'

class ArticleTest < ActiveSupport::TestCase
  def setup
    @a = articles(:jquery)
  end

  def teardown
    @a = nil
  end

  test "article save" do
    article = Article.new({
      :url => 'http://www.wings.msn.to',
      :title => 'サーバサイド技術の学び舎',
      :category => 'Script', :published => '2012-01-01',
      :access => 1, :closed => false
    })
    assert article.save, 'Failed saving'
  end

  test "article save2" do
    article = Article.new({
      :url => 'ftp://www.web-deli.com',
      :title => 'WebDeli',
      :category => 'Script', :published => '2012-01-01',
      :access => 1, :closed => false
    })
    assert !article.save, 'Failed validating'
    assert_equal article.errors.size, 1, 'Failed error count'
    assert_not_nil article.errors[:url], 'Failed url validate'
  end

test "article get" do
  assert_raise ActiveRecord::RecordNotFound ,
    'record is found' do
    Article.find(108)
  end

  article = Article.find(1)
  assert_instance_of Article, article,
    'article is not instance of Article'
  assert_present article.url, 'url is blank'
  assert_match /[0-9]{4}-[0-9]{1,2}-[0-9]{1,2}/,
    article.published.to_s,
    'published is missmatch'
  assert_respond_to article, :save,
    'object does not have save method'
end

  #test "flunk sample" do
  #  flunk 'failed by flunk'
  #end

  test "fixture hash" do
    article = Article.where(:title => 'jQuery逆引きリファレンス').first
    assert_instance_of Article, article, 'article is not instance of Article'
    assert_equal articles(:jquery).url, article.url, 'Url value is wrong'
    assert_equal articles(:jquery).published, article.published,
      'Published value is wrong'
  end

  test "fixture hash2" do
    article = Article.where(:title => 'jQuery逆引きリファレンス').first
    assert_instance_of Article, article, 'article is not instance of Article'
    assert_equal @a.url, article.url, 'Url value is wrong'
    assert_equal @a.published, article.published, 'Published value is wrong'
  end

  # test "the truth" do
  #   assert true
  # end
end
